Index: /trunk/src/lib/collision_detection/aabb_tree_node.cc
===================================================================
--- /trunk/src/lib/collision_detection/aabb_tree_node.cc	(revision 10012)
+++ /trunk/src/lib/collision_detection/aabb_tree_node.cc	(revision 10013)
@@ -17,6 +17,7 @@
 #include "aabb_tree_node.h"
 #include "aabb.h"
-
 #include "bv_tree.h"
+
+#include "collision_tube.h"
 
 #include "matrix.h"
@@ -532,5 +533,5 @@
         (treeNode->nodeRight == NULL && treeNode->nodeLeft == NULL)) )
     {
-      nodeA->registerCollision(nodeA, nodeB, (BoundingVolume*)this->bvElement, (BoundingVolume*)treeNode->bvElement);
+      CoRe::CollisionTube::getInstance()->registerCollisionEvent( nodeA, nodeB, (BoundingVolume*)this->bvElement, (BoundingVolume*)treeNode->bvElement);
     }
 
Index: /trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- /trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 10012)
+++ /trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 10013)
@@ -18,4 +18,6 @@
 #include "obb_tree.h"
 #include "obb.h"
+
+#include "collision_tube.h"
 
 #include "matrix.h"
@@ -477,4 +479,8 @@
     return;
 
+#warning this should be done
+//   if( !CoRe::CollisionTube::getInstance()->isReactive( *nodeA, *nodeB) )
+//     return;
+
 //   float distanceMax = this->bvElement->radius + ((OBBTreeNode*)treeNode)->bvElement->radius;
 //   float distance = fabs((nodeA->getAbsCoor() - nodeB->getAbsCoor()).len());
@@ -566,6 +572,6 @@
         (treeNode->nodeRight == NULL && treeNode->nodeLeft == NULL)) )
     {
-//       PRINTF(0)("----------------------------------------------\n\n\n\n\n\n--------------------------------\n\n\n");
-      nodeA->registerCollision(nodeA, nodeB, (BoundingVolume*)this->bvElement, (BoundingVolume*)treeNode->bvElement);
+      //PRINTF(0)("----------------------------------------------\n\n\n\n\n\n--------------------------------\n\n\n");
+      CoRe::CollisionTube::getInstance()->registerCollisionEvent( nodeA, nodeB, (BoundingVolume*)this->bvElement, (BoundingVolume*)treeNode->bvElement);
     }
 
Index: /trunk/src/lib/collision_reaction/Makefile.am
===================================================================
--- /trunk/src/lib/collision_reaction/Makefile.am	(revision 10012)
+++ /trunk/src/lib/collision_reaction/Makefile.am	(revision 10013)
@@ -5,7 +5,8 @@
 
 libORXcr_a_SOURCES = cr_engine.cc \
+                     collision_tube.cc \
                      collision.cc \
                      collision_event.cc \
-                     collision_handle.cc \
+                     collision_filter.cc \
                      collision_reaction.cc \
                      cr_object_damage.cc \
@@ -16,7 +17,8 @@
 
 noinst_HEADERS =     cr_engine.h \
+                     collision_tube.h \
                      collision.h \
                      collision_event.h \
-                     collision_handle.h \
+                     collision_filter.h \
                      cr_defs.h \
                      collision_reaction.h \
Index: /trunk/src/lib/collision_reaction/collision.cc
===================================================================
--- /trunk/src/lib/collision_reaction/collision.cc	(revision 10012)
+++ /trunk/src/lib/collision_reaction/collision.cc	(revision 10013)
@@ -19,35 +19,36 @@
 #include "debug.h"
 
-/**
- *  standard constructor
- */
-Collision::Collision ()
+namespace CoRe
 {
-  this->flushCollisionEvents();
-}
+
+  /**
+   *  standard constructor
+   */
+  Collision::Collision ()
+  {
+    this->reset();
+  }
 
 
-/**
- *  standard deconstructor
- */
-Collision::~Collision ()
-{
-}
+  /**
+   *  standard deconstructor
+   */
+  Collision::~Collision ()
+  {}
 
 
-/**
- * flushes the CollisionEvent list
- */
-void Collision::flushCollisionEvents()
-{
-  this->entityA = NULL;
-  this->entityB = NULL;
+  /**
+   * resets all variable states to initial values
+   */
+  void Collision::reset()
+  {
+    this->_entityA = NULL;
+    this->_entityB = NULL;
 
-  this->entityACollide = false;
-  this->entityBCollide = false;
+    this->_entityACollide = false;
+    this->_entityBCollide = false;
 
-  this->bDispatched = true;
+    this->_collisionEvents.clear();
+  }
 
-  this->collisionEvents.clear();
 }
-
Index: /trunk/src/lib/collision_reaction/collision.h
===================================================================
--- /trunk/src/lib/collision_reaction/collision.h	(revision 10012)
+++ /trunk/src/lib/collision_reaction/collision.h	(revision 10013)
@@ -1,9 +1,13 @@
 /*!
  * @file collision.h
- *  Definition of a collision as a two WE hit each other
+ *  Definition of a collision relation of two WorldEntities
  *
- *  A is shared between two WorldEntity's CollisionHandles if both are subscribed to this event. In this case only one
+ *  Is shared between two WorldEntity's CollisionHandles if both are subscribed to this event. In this case only one
  *  of the two CollisionHandles will calculate the CollisionReaction and the bDispatched flag will be set afterwards
  *  to signal that it's already cared about and should be ignored.
+ *
+ *  The collisions itself are saved in this container (CollisionEvent). Since there can be multiple collision events
+ *  for one collision. Imagine: two objects are intersecting (this throws a Collision): many collision boxes will fire
+ *  each of this boxes will "create" a CollisionEvent.
  */
 
@@ -14,57 +18,80 @@
 #include <vector>
 
+
+
 class WorldEntity;
 class BoundingVolume;
-class CollisionEvent;
 
-//! A class representing a simple collision
-class Collision
+namespace CoRe
 {
+
+  class CollisionEvent;
+
+  //! A class representing a simple collision
+  class Collision
+  {
+
+    typedef std::vector<CollisionEvent*>                  CollisionVector;  //!< the vector containing all collision events
+    typedef std::vector<CollisionEvent*>::iterator        Iterator;         //!< iterator definition
+    typedef std::vector<CollisionEvent*>::const_iterator  ConstIterator;   //!< constant iterator definition
+
+
   public:
+
     Collision();
     virtual ~Collision();
 
     /** collides two WorldEntities @param entityA world entity A, @param entityB world entity B, @param bvA volume A @param bvB volumeB */
-    inline void collide(WorldEntity* entityA, WorldEntity* entityB) { this->entityA = entityA; this->entityB = entityB; this->bDispatched = false; }
+    inline void collide(WorldEntity* entityA, WorldEntity* entityB) { this->_entityA = entityA; this->_entityB = entityB; }
 
 
-    /** @return Collision WorldEntity A */
-    inline WorldEntity* getEntityA() const { return this->entityA; }
-    /** @return Collision WorldEntity B */
-    inline WorldEntity* getEntityB() const { return this->entityB; }
-    /** @return true if Entity A collides */
-    inline bool isEntityACollide() const { return this->entityACollide; }
-    /** sets the flag if it reacts @param flag true if it should react on entityA*/
-    inline void setEntityACollide(bool flag) { this->entityACollide = flag; }
-    /** @return true if Entity B collides */
-    inline bool isEntityBCollide() const { return this->entityBCollide; }
-    /** sets the flag if it reacts @param flag true if it should react on entityB*/
-    inline void setEntityBCollide(bool flag) { this->entityACollide = flag; }
+    /* list stuff */
+  public:
+
+    /** registers a @param event CollisionEvent to take place */
+    inline void registerCollisionEvent(CollisionEvent* event) { this->_collisionEvents.push_back(event); }
+
+    void reset();
 
 
-    /** @returns true if this Collision has already been dispatched */
-    inline bool isDispatched() { return this->bDispatched; }
-    /** sets the dispatched flag to true */
-    inline void dispatched() { this->bDispatched = true; }
-
-    /** registers a @param event CollisionEvent to take place */
-    inline void registerCollisionEvent(CollisionEvent* event) { this->collisionEvents.push_back(event); this->bDispatched = false;}
-    /** @returns a vector of collision events */
-    inline const std::vector<CollisionEvent*>& getCollisionEvents() const { return this->collisionEvents; }
+    /** @returns iterator pointing to the beginning of the collision event vector */
+    inline Iterator       begin()        { return this->_collisionEvents.begin(); }
+    /** @returns const iterator pointing to the beginning of the collision event vector */
+    inline ConstIterator  begin() const  { return this->_collisionEvents.begin(); }
+    /** @returns iterator pointing to the end of the collision event vector */
+    inline Iterator       end()          { return this->_collisionEvents.end(); }
+    /** @returns const iterator pointing to the end of the collision event vector */
+    inline ConstIterator  end() const    { return this->_collisionEvents.end(); }
 
 
-    void flushCollisionEvents();
+    /* misc interface functions */
+  public:
+    /** @return Collision WorldEntity A */
+    inline WorldEntity* getEntityA() const { return this->_entityA; }
+    /** @return Collision WorldEntity B */
+    inline WorldEntity* getEntityB() const { return this->_entityB; }
+    inline bool same(const WorldEntity& entityA, WorldEntity& entityB) const {
+      return ((this->_entityA == &entityA && this->_entityB == &entityB) || (this->_entityA == &entityB && this->_entityB == &entityA)); }
+
+    /** @return true if Entity A collides */
+    inline bool isEntityACollide() const { return this->_entityACollide; }
+    /** sets the flag if it reacts @param flag true if it should react on entityA*/
+    inline void setEntityACollide(bool flag) { this->_entityACollide = flag; }
+    /** @return true if Entity B collides */
+    inline bool isEntityBCollide() const { return this->_entityBCollide; }
+    /** sets the flag if it reacts @param flag true if it should react on entityB*/
+    inline void setEntityBCollide(bool flag) { this->_entityBCollide = flag; }
 
 
   private:
-    WorldEntity*                 entityA;                       //!< the collision body A
-    WorldEntity*                 entityB;                       //!< the collision body B
-    bool                         entityACollide;                //!< true if entity A is subscribed for collision reaction
-    bool                         entityBCollide;                //!< true if entity B is subscribed for collision reaction
+    WorldEntity*                 _entityA;                       //!< the collision body A
+    WorldEntity*                 _entityB;                       //!< the collision body B
+    bool                         _entityACollide;                //!< true if entity A is subscribed for collision reaction
+    bool                         _entityBCollide;                //!< true if entity B is subscribed for collision reaction
 
-    bool                         bDispatched;                   //!< true if this collision has already been dispatched
+    CollisionVector              _collisionEvents;               //!< the collision event list
 
-    std::vector<CollisionEvent*> collisionEvents;               //!< the collision event list
-};
+  };
+}
 
 #endif /* _COLLISION_H */
Index: /trunk/src/lib/collision_reaction/collision_event.cc
===================================================================
--- /trunk/src/lib/collision_reaction/collision_event.cc	(revision 10012)
+++ /trunk/src/lib/collision_reaction/collision_event.cc	(revision 10013)
@@ -19,23 +19,25 @@
 #include "debug.h"
 
-/**
- *  standard constructor
- */
-CollisionEvent::CollisionEvent ()
+namespace CoRe
 {
-  this->entityA = NULL;
-  this->entityB = NULL;
-  this->bvA = NULL;
-  this->bvB = NULL;
+
+  /**
+   *  standard constructor
+   */
+  CollisionEvent::CollisionEvent ()
+  {
+    this->entityA = NULL;
+    this->entityB = NULL;
+    this->bvA = NULL;
+    this->bvB = NULL;
+  }
+
+
+  /**
+   *  standard deconstructor
+   */
+  CollisionEvent::~CollisionEvent ()
+  {}
+
 }
 
-
-/**
- *  standard deconstructor
- */
-CollisionEvent::~CollisionEvent ()
-{
-}
-
-
-
Index: /trunk/src/lib/collision_reaction/collision_event.h
===================================================================
--- /trunk/src/lib/collision_reaction/collision_event.h	(revision 10012)
+++ /trunk/src/lib/collision_reaction/collision_event.h	(revision 10013)
@@ -2,4 +2,10 @@
  * @file collision_event.h
  *  Definition of a collision event
+ *
+ *  A collision event represents a collision of two bouning boxes. Every CollisionEvent belongs to a Collision object that
+ *  represents the collision of two WorldEntities.
+ *
+ *  There are different types of collisions: obb collisions and bsp collisions. Both collision types use different techniques
+ *  to represent collisions. This is why this class saves bounding boxes from the OBB as well as the planes from BSP.
  */
 
@@ -8,4 +14,5 @@
 
 #include "vector.h"
+#include "cr_engine.h"
 
 #include "cr_defs.h"
@@ -16,55 +23,65 @@
 class Plane;
 
+namespace CoRe
+{
+
+  //! A class representing a simple collision
+  class CollisionEvent
+  {
+  public:
+    CollisionEvent();
+    virtual ~CollisionEvent();
+
+    /** collides two WorldEntities @param entityA world entity A, @param entityB world entity B, @param bvA volume A @param bvB volumeB */
+    inline void collide(CREngine::CollisionType type, WorldEntity* entityA, WorldEntity* entityB, BoundingVolume* bvA, BoundingVolume* bvB)
+    { this->collisionType = type; this->entityA = entityA; this->entityB = entityB; this->bvA = bvA; this->bvB = bvB; }
+    /** collides two WorldEntities @param entity world entity , @param ground ground plane, @param position position on the ground */
+    inline void collide(CREngine::CollisionType type, WorldEntity* entity, WorldEntity* groundEntity, Vector normal, Vector position, bool bInWall)
+    {
+      this->collisionType = type;
+      this->entityA = entity;
+      this->entityB = groundEntity;
+      this->groundNormal = normal;
+      this->position = position;
+      this->bInWall = bInWall;
+    }
 
 
-//! A class representing a simple collision
-class CollisionEvent {
- public:
-   CollisionEvent();
-  virtual ~CollisionEvent();
+    /** @return CollisionEvent WorldEntity A */
+    inline const WorldEntity* getEntityA() const  { return this->entityA; }
+    /** @return CollisionEvent WorldEntity B */
+    inline const WorldEntity* getEntityB() const  { return this->entityB; }
+    /** @return Bounding Volume from EntityA */
+    inline const BoundingVolume* getBVA() const { return this->bvA; }
+    /** @return Bounding Volume from EntityB */
+    inline const BoundingVolume* getBVB() const {  return this->bvB;  }
 
-  /** collides two WorldEntities @param entityA world entity A, @param entityB world entity B, @param bvA volume A @param bvB volumeB */
-  inline void collide(int type, WorldEntity* entityA, WorldEntity* entityB, BoundingVolume* bvA, BoundingVolume* bvB)
-  { this->collisionType = type; this->entityA = entityA; this->entityB = entityB; this->bvA = bvA; this->bvB = bvB; }
-  /** collides two WorldEntities @param entity world entity , @param ground ground plane, @param position position on the ground */
-  inline void collide(int type, WorldEntity* entity, WorldEntity* groundEntity, Vector normal, Vector position, bool bInWall)
-  { this->collisionType = type; this->entityA = entity; this->entityB = groundEntity, this->groundNormal = normal; this->position = position; this->bInWall = bInWall; }
+    /** @return ground plane if collided with bsp model */
+    inline const Vector& getGroundNormal() const  { return this->groundNormal; }
+
+    /** @return position of the position, only accurate if this is a collision with the ground!!! */
+    inline const Vector& getCollisionPosition() const  {  return this->position;  }
+
+    /** @return the type of the collision */
+    inline int getType() const  {  return this->collisionType;  }
+
+    /** @return true if the entity is in the wall */
+    inline bool isInWall() const  {  return this->bInWall;  }
 
 
-  /** @return CollisionEvent WorldEntity A */
-  inline WorldEntity* getEntityA() const { return this->entityA; }
-  /** @return CollisionEvent WorldEntity B */
-  inline WorldEntity* getEntityB() const { return this->entityB; }
-  /** @return Bounding Volume from EntityA */
-  inline BoundingVolume* getBVA() const { return this->bvA; }
-  /** @return Bounding Volume from EntityB */
-  inline BoundingVolume* getBVB() const { return this->bvB; }
+  private:
+    WorldEntity*      entityA;                       //!< the collision body A
+    WorldEntity*      entityB;                       //!< the collision body B
 
-  /** @return ground plane if collided with bsp model */
-  inline Vector getGroundNormal() { return this->groundNormal; }
+    BoundingVolume*   bvA;                           //!< reference to the bounding volume A
+    BoundingVolume*   bvB;                           //!< reference to the bounding volume B
 
-  /** @return position of the position, only accurate if this is a collision with the ground!!! */
-  inline Vector getCollisionPosition() { return this->position; }
+    Vector            groundNormal;                  //!< the ground plane with which it collides (only for bsp-model collisions
+    Vector            position;                      //!< position of the collision on the ground plane
 
-  /** @return the type of the collision */
-  inline int getType() { return this->collisionType; }
+    bool              bInWall;                       //!< true if is in wall
+    int               collisionType;                 //!< collision type
+  };
 
-  /** @return true if the entity is in the wall */
-  inline bool isInWall() { return this->bInWall; }
-
-
- private:
-  WorldEntity*      entityA;                       //!< the collision body A
-  WorldEntity*      entityB;                       //!< the collision body B
-
-  BoundingVolume*   bvA;                           //!< reference to the bounding volume A
-  BoundingVolume*   bvB;                           //!< reference to the bounding volume B
-
-  Vector            groundNormal;                  //!< the ground plane with which it collides (only for bsp-model collisions
-  Vector            position;                      //!< position of the collision on the ground plane
-
-  bool              bInWall;                       //!< true if is in wall
-  int               collisionType;                 //!< collision type
-};
-
+}
 #endif /* _COLLISION_EVENT_H */
Index: /trunk/src/lib/collision_reaction/collision_filter.cc
===================================================================
--- /trunk/src/lib/collision_reaction/collision_filter.cc	(revision 10013)
+++ /trunk/src/lib/collision_reaction/collision_filter.cc	(revision 10013)
@@ -0,0 +1,200 @@
+/*
+   orxonox - the future of 3D-vertical-scrollersf
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_REACTION
+
+#include "collision_filter.h"
+
+#include "world_entity.h"
+
+#include "collision.h"
+#include "collision_event.h"
+
+
+#include "debug.h"
+
+#include <vector>
+
+
+namespace CoRe
+{
+
+  ObjectListDefinition(CollisionFilter);
+
+  /**
+   * standard constructor
+   * @todo this constructor is not jet implemented - do it
+  */
+  CollisionFilter::CollisionFilter (WorldEntity* owner)
+  {
+    this->registerObject(this, CollisionFilter::_objectList);
+
+    this->_owner = owner;
+
+    this->_bContinuousPoll = false;
+    this->_bStopOnFirstCollision = false;
+    this->_bReactive = false;
+  }
+
+
+  /**
+   * standard deconstructor
+  */
+  CollisionFilter::~CollisionFilter ()
+  {
+    this->unsubscribeReactions();
+  }
+
+
+  /**
+   * subscribe reaction
+   */
+  void CollisionFilter::subscribeReaction(CoRe::CREngine::ReactionType type, const ClassID& target1)
+  {
+    // check if its a valid type
+    if( likely(this->validCRType( type)))
+    {
+      //check if this class isn't already registered
+      TargetIterator it = this->_filters[type].begin();
+      for(; it != this->_filters[type].end(); it++)
+      {
+        if( unlikely(*it == target1))
+          return;
+      }
+
+      // so subscribe the reaction finally
+      this->_filters[type].push_back(target1);
+      this->_bReactive = true;
+    }
+  }
+
+
+  /**
+   * subscribe for a reaction
+   */
+  void CollisionFilter::subscribeReaction(CoRe::CREngine::ReactionType type, const ClassID& target1, const ClassID& target2)
+  {
+    this->subscribeReaction(type, target1);
+    this->subscribeReaction(type, target2);
+  }
+
+
+  /**
+   * subscribe for a reaction
+   */
+  void CollisionFilter::subscribeReaction(CoRe::CREngine::ReactionType type, const ClassID& target1, const ClassID& target2, const ClassID& target3)
+  {
+    this->subscribeReaction(type, target1);
+    this->subscribeReaction(type, target2);
+    this->subscribeReaction(type, target3);
+  }
+
+  /**
+   * unsubscribe from a specific collision reaction
+   */
+  void CollisionFilter::unsubscribeReaction(CoRe::CREngine::ReactionType type)
+  {
+    if( likely(this->validCRType( type)))
+      this->_filters[type].clear();
+
+    for( int i = 0; i < CREngine::CR_NUMBER; i++)
+    {
+      if( this->_filters[i].size() > 0)
+      {
+        this->_bReactive = true;
+        break;
+      }
+    }
+
+  }
+
+  /**
+   * unsubscribe from all collision reactions
+   */
+  void CollisionFilter::unsubscribeReactions()
+  {
+    for(int i = 0; i < CREngine::CR_NUMBER; i++)
+      this->_filters[i].clear();
+
+    this->_bReactive = false;
+  }
+
+
+
+  /**
+   * tests if the owner WorldEntity is listening to collisions from another specif WorldEntity entity
+   *  @param entity WorldEntity to test against
+   *
+   * This is the most important interface function of this class: it performs a check and returns true
+   * if the WorldEntity entity is actualy responsive for a certain other WorldEntity
+   */
+  bool CollisionFilter::operator()(const WorldEntity& entity) const
+  {
+//     PRINTF(0)("operator()(const WorldEntity& entity)\n");
+
+    // if there are no installed criterions just ommit and return
+    if( !this->isReactive())
+      return false;
+
+    // goes through all registered filter criterions and looks for matches
+    for( int i = 0; i < CREngine::CR_NUMBER; i++ )
+    {
+      TargetIteratorConst it = this->_filters[i].begin();
+      for(; it != this->_filters[i].end(); it++ )
+      {
+//          PRINTF(0)("[%i] check %s is a %s?\n", i, entity.getClassName().c_str(), (*it).name().c_str());
+        if( unlikely(entity.isA(*it) ) )
+          return true;
+      }
+    }
+
+    return false;
+  }
+
+
+  /**
+  * tests if the owner WorldEntity is listening to collisions from another specif WorldEntity entity
+  *  @param entity WorldEntity to test against
+  *
+  * This is the most important interface function of this class: it performs a check and returns true
+  * if the WorldEntity entity is actualy responsive for a certain other WorldEntity
+   */
+  bool CollisionFilter::operator()(const WorldEntity& entity, const CREngine::ReactionType type) const
+  {
+    assert(&entity != NULL);
+
+//     PRINTF(0)("operator()(const WorldEntity& entity, const CREngine::ReactionType type)\n");
+    // if there are no installed criterions just omit and return
+    if( !this->isReactive())
+      return false;
+
+
+    // goes through all registered filter criterions and looks for matches
+    TargetIteratorConst it = this->_filters[type].begin();
+    for(; it != this->_filters[type].end(); it++ )
+    {
+//        PRINTF(0)("size: %i - %s is a %s?\n", this->_filters[type].size(), entity.getClassName().c_str(), (*it).name().c_str());
+      if( entity.isA(*it))
+        return true;
+    }
+
+    return false;
+  }
+
+
+
+} // namespace end
+
+
+
Index: /trunk/src/lib/collision_reaction/collision_filter.h
===================================================================
--- /trunk/src/lib/collision_reaction/collision_filter.h	(revision 10013)
+++ /trunk/src/lib/collision_reaction/collision_filter.h	(revision 10013)
@@ -0,0 +1,93 @@
+/*!
+ * @file collision_filter.h
+ * @brief Definition of a collision filter: checks if a certain WorldEntity is responsive for another WorldEntity
+ *
+*/
+
+#ifndef _COLLISION_FILTER_H
+#define _COLLISION_FILTER_H
+
+#include "base_object.h"
+#include "cr_engine.h"
+
+#include <vector>
+#include <list>
+
+
+class Collision;
+class WorldEntity;
+
+namespace CoRe
+{
+
+  class CollisionReaction;
+
+
+  /**
+   * A class for defining collision reactions and storing events (functional object)
+   *
+   * This class basically checks if the owner of this filter (a WorldEntity) is responsive for a certain other WorldEntity.
+   * The check is performed via the operator() (therefore it's a functional objects). For each CollisionReaction there is a list
+   * of WorldEntities (their ClassIDs) to which it listens to.
+   */
+  class CollisionFilter : public BaseObject
+  {
+    ObjectListDeclaration(CollisionFilter);
+
+
+    typedef std::vector<ClassID>::iterator        TargetIterator;
+    typedef std::vector<ClassID>::const_iterator  TargetIteratorConst;
+
+    /* Constructor/Deconstructors */
+  public:
+    CollisionFilter(WorldEntity* owner);
+    virtual ~CollisionFilter();
+
+  private:
+    CollisionFilter(const CollisionFilter& collisionFilter) {}
+    WorldEntity*                  _owner;                   //!< the worldenity this reaction will be applied on
+
+
+  public:
+    /* Defines Operators */
+    bool operator()(const WorldEntity& entity) const;
+    bool operator()(const WorldEntity& entity, const CREngine::ReactionType type) const;
+
+
+    /* Collision Reaction subscription unsubscription Block */
+  public:
+    void subscribeReaction(CREngine::ReactionType type, const ClassID& target1);
+    void subscribeReaction(CREngine::ReactionType type, const ClassID& target1, const ClassID& target2);
+    void subscribeReaction(CREngine::ReactionType type, const ClassID& target1, const ClassID& target2, const ClassID& target3);
+
+    void unsubscribeReaction(CREngine::ReactionType type);
+    void unsubscribeReactions();
+
+  private:
+    std::vector<ClassID>          _filters[CREngine::CR_NUMBER];  //!< an array of filter targets: for each collision type a list of filter objects
+
+
+    /* Misc State Informations */
+  public:
+    /** @returns true if this handle should be pulled also if there are no collisions, can also be set with this function (reference)*/
+    inline bool isContinousPoll() { return this->_bContinuousPoll; }
+    /** @returns true if this filter should be pulled always */
+    inline bool isContinousPoll() const { return this->_bContinuousPoll; }
+    /** @returns true if this filter is reactive i.e. at least one filter criterion installed */
+    inline bool isReactive() const { return this->_bReactive; }
+
+
+  private:
+    /** @returns true if this @param type Collision Reaction type is a valid number */
+    inline bool validCRType(const CREngine::ReactionType& type) const {return (type >= 0 && type < CREngine::CR_NUMBER); }
+
+
+  private:
+    bool                          _bContinuousPoll;         //!< if this is true
+    bool                          _bStopOnFirstCollision;   //!< true if the cd of this object should be terminated after one match
+    bool                          _bReactive;               //!< true if this class has at least one filter criterion == one target
+
+  };
+
+}
+#endif /* _COLLISION_FILTER_H */
Index: /trunk/src/lib/collision_reaction/collision_reaction.cc
===================================================================
--- /trunk/src/lib/collision_reaction/collision_reaction.cc	(revision 10012)
+++ /trunk/src/lib/collision_reaction/collision_reaction.cc	(revision 10013)
@@ -11,5 +11,4 @@
    ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer: ...
 */
 
@@ -18,23 +17,24 @@
 #include "collision_reaction.h"
 
+namespace CoRe
+{
+
+  ObjectListDefinition(CollisionReaction);
+
+  /**
+   *  standard constructor
+   */
+  CollisionReaction::CollisionReaction ()
+      : BaseObject()
+  {
+    this->registerObject(this, CollisionReaction::_objectList);
+  }
 
 
-ObjectListDefinition(CollisionReaction);
+  /**
+   *  standard deconstructor
+   */
+  CollisionReaction::~CollisionReaction ()
+  {}
 
-/**
- *  standard constructor
- */
-CollisionReaction::CollisionReaction ()
-  : BaseObject()
-{
-  this->registerObject(this, CollisionReaction::_objectList);
 }
-
-
-/**
- *  standard deconstructor
- */
-CollisionReaction::~CollisionReaction ()
-{
-}
-
Index: /trunk/src/lib/collision_reaction/collision_reaction.h
===================================================================
--- /trunk/src/lib/collision_reaction/collision_reaction.h	(revision 10012)
+++ /trunk/src/lib/collision_reaction/collision_reaction.h	(revision 10013)
@@ -9,14 +9,15 @@
 #include "base_object.h"
 
-
-
-class Collision;
 class WorldEntity;
 
+namespace CoRe
+{
 
-//! A class representing a simple collision
-class CollisionReaction : public BaseObject
-{
-  ObjectListDeclaration(CollisionReaction);
+  class Collision;
+
+  //! A class representing a simple collision
+  class CollisionReaction : public BaseObject
+  {
+    ObjectListDeclaration(CollisionReaction);
   public:
     CollisionReaction();
@@ -25,6 +26,4 @@
     virtual void reactToCollision(Collision* collision) = 0;
 
-    virtual void update(WorldEntity* owner) {}
-
     /** use this to do some collision offline calculations, only called for bContinuousPoll == true */
     inline bool isContinuousPoll() const { return this->bContinuousPoll; }
@@ -32,5 +31,6 @@
   private:
     bool                    bContinuousPoll;       //!< if true the collision rection function is also called, if there was no collision
-};
+  };
 
+}
 #endif /* _COLLISION_REACTION_H */
